<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2009 Georg Ringer <www.ringer.it>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
* Hook for the 'ttnewsgenericmarkers' extension.
*
* @author	Georg Ringer <http://www.ringer.it/>
*/

class tx_ttnewsgenericmarkers_fe {

	// hook for tt_news
	function extraItemMarkerProcessor($markerArray, $row, $lConf, &$pObj) {


		// configuration of chgallery
		$confDefault = $pObj->conf['genericmarkers.'];

		if (!is_array($confDefault)) {
			return $markerArray;
		}

		// merge with special configuration (based on chosen CODE [SINGLE, LIST, LATEST]) if this is available
		if (is_array($confDefault[$pObj->config['code'].'.'])) {
			$conf = t3lib_div::array_merge_recursive_overrule($confDefault, $confDefault[$pObj->config['code'].'.']);
		} else {
			$conf = $confDefault;
		}
		
		if (is_array($conf)) {

			if ($conf['data']!='') {
				foreach (t3lib_div::trimExplode(',',$conf['data']) as $key) {
					$pObj->cObj->data['generic_'.$key]    = $row[$key];
				}
			}


			foreach($conf as $key=>$value) {
				$key2 = trim($key, '.');
				$markerArray['###GENERIC_'.strtoupper($key2).'###'] = $pObj->cObj->cObjGetSingle($conf[$key2] , $conf[$key] );
			
			}
		}



		return $markerArray;
	}

	// hook for tt_news
	function extraGlobalMarkerProcessor(&$pObj, $markerArray) {
		
		// configuration of chgallery
		$confDefault = $pObj->conf['globalmarkers.'];
		
		if (!is_array($confDefault)) {
			return $markerArray;
		}
		
		// merge with special configuration (based on chosen CODE [SINGLE, LIST, LATEST]) if this is available
		if (is_array($confDefault[$pObj->config['code'].'.'])) {
			$conf = t3lib_div::array_merge_recursive_overrule($confDefault, $confDefault[$pObj->config['code'].'.']);
		} else {
			$conf = $confDefault;
		}
		
		if (is_array($conf)) {		

			
			
			foreach($conf as $key=>$value) {
				$key2 = trim($key, '.');
				$markerArray['###GLOBAL_'.strtoupper($key2).'###'] = $pObj->cObj->cObjGetSingle($conf[$key2] , $conf[$key] );
			}
		}
		
		
		return $markerArray;
	}

}

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/tx_ttnewsgenericmarkers_fe/class.tx_ttnewsgenericmarkers_fe.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/tx_ttnewsgenericmarkers_fe/class.tx_ttnewsgenericmarkers_fe.php']);
}

?>